char M_PROGNAME[] ="website2url";
char M_TITLE[] ="website to url Program Ver.1.01c (c)2011 saibara.\n";
char M_HELP[] =
#ifdef _WINDOWS
"Usage : website2url.exe [-s] <file.website>[..]\n"
"Option : -s : Silent mode.\n"
#else
"Usage : website2url.exe <file.website>[..]\n"
#endif
;
/*
  Ver.1.00 Ƃ肠ϊ
  Ver.1.01 R\[vOƂĂ삷悤ɃvO
 */
#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>

#include "s_value.h"
#include "s_malloc.h"

#pragma warning (disable : 4996)
#ifdef _WINDOWS
#include "windebug.f"
#endif
#include "s_fopen.f"
#include "s_fgetl.f"
#include "s_sptab.f"
#include "basename.f"
#include "pickstr.f"

// TCg[h̃tO
int silent_mode = FALSE;

void printhelp(void)
{
  char tmp[1024];
  sprintf(tmp,
	"%s\n\nwebsite(ŒTCgV[gJbg)R}hCŎw肷邩A\n"
	"svȌɒDrag&DropĂ\n%s",M_TITLE,M_HELP);
#ifdef _WINDOWS
  MessageBox(NULL,tmp,M_PROGNAME,MB_OK);
#else
  printf(tmp);
#endif
  exit(0);
}

char def_name[] = "-";

// t@CopenBY_HANDLE_FILE_INFORMATIONl
// lɎsƂTRUEԂBFALSE
int get_fileinfo(BY_HANDLE_FILE_INFORMATION *fileinfo,char *filename)
{
  HANDLE hfile;
  int flag;

  hfile = CreateFile(filename,GENERIC_READ,0,0,OPEN_EXISTING, 0, 0);
  if(hfile == INVALID_HANDLE_VALUE)
  {
    return(TRUE);
  }
  flag = GetFileInformationByHandle(hfile,fileinfo);
  CloseHandle(hfile);
  return(flag == 0);
}

// Q̃t@CIɓt@CwĂ邩ǂ𔻒肷
// łTRUEAĂFALSE
// FQƂ݂Ȃt@C̏ꍇ͓t@CłFALSEɂȂ
int is_same_filename(char file1[],char file2[])
{
  BY_HANDLE_FILE_INFORMATION fileinf1,fileinf2;

  if(get_fileinfo(&fileinf1,file1)) return(FALSE);
  if(get_fileinfo(&fileinf2,file2)) return(FALSE);
  return(  (fileinf1.dwVolumeSerialNumber == fileinf2.dwVolumeSerialNumber)
	  && (fileinf1.nFileIndexHigh == fileinf2.nFileIndexHigh)
	  && (fileinf1.nFileIndexLow  == fileinf2.nFileIndexLow));
  return(FALSE);
}

void weblink2url(char infile[],char outfile[])
{
  FILE *fpin,*fpout;
  char *l,*d;
  int mode;

  if(is_same_filename(infile,outfile)) { printf("Input file is same to Output file. Skip.\n"); return; }

  fpin = s_fopen(infile,"r");
  if(fpin == NULL) { printf("Can't open input file\n"); return;}
  fpout = s_fopen(outfile,"w");
  if(fpout == NULL)
  {
    printf("Can't open output file\n");
    fclose(fpin);
    return;
  }

  mode = 0;
  while((l = s_fgetl(fpin)) != NULL)
    {
	  d = skip_sptab(l);
	  if(*d == '[')
	    {
		  mode = 0;
	      if(strncmp(d,"[InternetShortcut]",strlen("[InternetShortcut]"))== 0)
		    {
			  mode = 1;
		    }
	    }
      if(mode == 1) fprintf(fpout,"%s\n",l);
	  free(l);
    }
  s_fclose(fpin);
  s_fclose(fpout);
}

int count_quote(char *d)
{
  int cnt;
  cnt = 0;
  while(*d != '\0')
	{
	  if(*d == '"') cnt++;
	  d++;
	}
  return(cnt);
}

int is_unmatched_quote(char *d)
{
  return((count_quote(d)%2) == 1);
}

char *remove_quote(char *in)
{
  char *ret;
  char *d,*e;
  ret = xalloc(char,strlen(in)+1-count_quote(in));
  d = in;
  e = ret;
  while(*d != '\0')
  {
	if(*d != '"') { *e = *d; e++; }
	d++;
  }
  return(ret);
}

int main(int argc,char *argv[])
{
  char *infilename,*basename,*outfilename;
  int flag;

  if((argc > 1) && (strcmp(argv[1],"-s")==0))
    { // -s IvVw肳ĂƃTCg[hɂ(R\[ʂ\Ȃ)
      argc--; argv++;
      silent_mode = TRUE;
    }
  if(argc == 1) printhelp();
#ifdef _WINDOWS
  if(!silent_mode)
    { // R\[ʂ\
      if(__argc != 1) CreateDebugConsole();
    }
#endif
  while(argc > 1)
    {
      infilename = remove_quote(argv[1]);
      if(!silent_mode) fprintf(stderr,"Now processing... %s\n",infilename);
      basename = get_base_name(infilename,1);
      flag = is_unmatched_quote(basename);
      outfilename=xalloc(char,strlen(basename)+1+3+1+(flag?1:0));
      strcpy(outfilename,basename);
      strcat(outfilename,".url");
      if(flag) strcat(outfilename,"\"");
      free(basename);
      if(!silent_mode) fprintf(stderr,"Output ... %s\n",outfilename);
      weblink2url(infilename,outfilename);
      free(infilename);
      free(outfilename);
      argc--; argv++;
    }
  if(!silent_mode)
    {
#ifdef _WINDOWS
      MessageBox(NULL,"ϊ܂",M_PROGNAME,MB_OK);
#else
      printf("ϊ܂\n");
      // system("pause");
#endif
    }
  exit(0);
}

#ifdef _WINDOWS
int WINAPI WinMain(
	HINSTANCE hInstance, 
	HINSTANCE hPrevInstance, 
	LPSTR lpCmdLine, 
	int nCmdShow)
{
  return(main(__argc,__argv));
}
#endif
